 %LoadFromSpec.m
 
function LoadFromSpec
global MSpScnList MSpf  MSpScn ImgFormatList;
global MotDetOff
persistent c0 cpd strChanFirst strChanLast strIncAng strLam
persistent strScanNum strFileName

if ~exist('MSpScnList')
   MSpScnList={};
end;
if isempty(MotDetOff),
	 MotDetOff={};
end;
if isempty(c0),
	c0=541;
end;
if isempty(cpd),
	cpd=268;
end;
if isempty(strChanFirst),
	strChanFirst='-';
end;
if isempty(strChanLast),
	strChanLast='-';
end;
if isempty(strIncAng),
	strIncAng='-';
end;
if isempty(strLam),
	strLam='1.55';
end;
if isempty(strScanNum),
	strScanNum='18';
end;
if isempty(strFileName),
	strFileName='MSpScanLiquidA.spec';
end;
 
f0=figure(...
'Position',[400,400,500,400],...
'tag','LoadFromSpec',...
'Name','MatSpecGUI: Load from SPEC',...
	'MenuBar', 'none', ...
'CloseRequestFcn',{@closeIt},...
'Color', get(0,'DefaultUicontrolBackgroundColor'), ...
'Visible','on');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');


hLbSpecFileName = uicontrol('Style','text',...
'BackgroundColor', [0.5 0.5 0.5], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',...
'SPEC file name:','Position',[25,350,80,22]);
hEdSpecFileName = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strFileName,'Position',[125,350,250,22]);
hBtSpecFileName=uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','Browse','Position',...
	[375,350,90,22],'Callback',{@specFileName_Callback});


hLbScanNumber = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',...
'Scan Number:','Position',[25,320,80,22]);
hEdScanNumber = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strScanNum,'Position',[125,320,150,22]);

hLbWaveLength= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',...
'WaveLength:','Position',[25,290,90,22]);
hEdWaveLength = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strLam,'Position',[125,290,150,22]);

hPnDetector= uicontrol('Style','frame','Position',[20,240,460,45],...
'String','1D detector info:');
%set(hPnDetector,'Enable','off');
hLDetector= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','1D detector info:','Position',[30,250,90,22]);
hLChannel= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','Central channel:','Position',[130,250,90,22]);
hEdChannel= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',num2str(c0,'%d'),'Position',[230,250,50,22]);
hLChannelDegrees= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','Channels/degrees:','Position',[280,250,90,22]);
hEdChannelDegrees= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',num2str(cpd,'%.2f'),'Position',[380,250,50,22]);

hfrOptions= uicontrol('Style','frame','Position',[20,100,460,120]);
hLOptions= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'String','----------------------OPTIONS------------------------','Position',[30,190,440,20]);
hLIncidenceangle= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',['Incidence ',...
'angle (for a beam deflected by a X-Ray mirror):'],...
'Position',[30,160,300,22]);
hEdIncidenceangle= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strIncAng,'Position',[380,160,50,22]);

hLDetectorPR= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','1D detector info:','Position',[30,110,90,22]);
hLFirstPixel= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','First Pixel:','Position',[130,110,90,22]);
hEdFirstPixel= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strChanFirst,'Position',[230,110,50,22]);
hLLastPixel= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','Last Pixel:','Position',[290,110,80,22]);
hEdLastPixel= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',strChanLast,'Position',[380,110,50,22]);

warning('off');
hLDataSetName= uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','Matlab data set name:','Position',[30,50,130,22]);
if ~isempty(MSpScnList),
	hPopDataSetName= uicontrol('Style','popupmenu','String',...
	MSpScnList, 'Position',[180,50,90,22],'Callback',...
	{@dataPopSetName_Callback});
else
	hPopDataSetName= uicontrol('Style','popupmenu','String',...
	{'-'}, 'Position',[180,50,90,22],'Callback',...
	{@dataPopSetName_Callback});
end;

hBtDataSetName=uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','New dataset name',...
	'Position',[30,20,120,22],'Callback',{@btDataSetName_Callback});
hEdDataSetName= uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','-','Position',[180,20,90,22]);

    
hBtSetMotorOffset=uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',...
	'Set Mot. offset','Position',[300,20,80,22],...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'Callback',{@setMotorOffset_Callback});
hBtLoad=uicontrol('Style','pushbutton',...
	'String','Load',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'Position',[380,20,80,22],'Callback',{@load_Callback});
warning('on')

function specFileName_Callback(hObject,eventdata)
persistent LocalDir
if isempty(LocalDir),
 LocalDir='';
end;

if isempty(LocalDir),
  mypath='./*.*';
else
    mypath=[LocalDir,'*.*'];
end;
[file,mypath]=uigetfile(mypath);

%[file,mypath]=uigetfile('*.spec',mypath);

LocalDir=mypath;

set(hEdSpecFileName,'String',[mypath,file]);
end

function btDataSetName_Callback(source, eventdata)
	scn=get(hEdDataSetName,'String');
	if ~isvarname(scn),
		msgbox(sprintf('Warning: %s is not a valid dataset name',scn));
		return;
	end;
	if ~any(strcmp(MSpScnList,scn)),
		n=length(MSpScnList);
		MSpScnList{n+1}=scn;
	end;
	set(hPopDataSetName,'String',MSpScnList);
  ii=find(strcmp(scn,MSpScnList),1);
  set(hPopDataSetName,'Value',ii);
end

function dataPopSetName_Callback(source, eventdata)
    str=get(source,'String');
    val=get(source,'Value');
    scn=str{val};
    set(hEdDataSetName,'String',scn);
end

function setMotorOffset_Callback(hObject,eventdata)
    str=get(hPopDataSetName,'String');
    val=get(hPopDataSetName,'Value');
    MSpScn=str{val};
    SetMotorOffset;
%disp('setMotorOffset');
end

function load_Callback(hObject,eventdata)
nMSpScnList=length(MSpScnList);

% Retrive fields from from GUI elements
SpecName=get(hEdSpecFileName,'String');
strFileName=SpecName;
strScanNum=get(hEdScanNumber,'String');
scNum=str2num(strScanNum);   

strChanFirst=get(hEdFirstPixel,'String');
firstPixel=str2num(strChanFirst);
strChanLast=get(hEdLastPixel,'String');
lastPixel=str2num(strChanLast);
if (isempty(firstPixel) | isempty(lastPixel)),
	ROI=[];
else,
	ROI=[firstPixel,lastPixel];
end;
strIncAng=get(hEdIncidenceangle,'String');
alfi=str2num(strIncAng);

str=get(hPopDataSetName,'String');
val=get(hPopDataSetName,'Value');
scn=str{val};
if ~isvarname(scn),
	warndlg(sprintf('Warning: %s is not a valid dataset name',scn));
	return;
end;

lbd=get(hEdWaveLength,'String');
lambda=str2num(lbd);

c0=get(hEdChannel,'String');
c0=str2num(c0);
cpd=get(hEdChannelDegrees,'String');
cpd=str2num(cpd);
strLam=get(hEdWaveLength,'String');
lambda=str2num(strLam);

%%%
if ~any(strcmp(MSpScnList,scn)),
	n=length(MSpScnList);
	MSpScnList{n+1}=scn;
end;
cmd=['global ',scn];
eval(cmd);
MSpScn=scn;

if ~isempty(ROI),
	cmd=[MSpScn,'=MSpUnspec2(SpecName,scNum,MotDetOff,''ROI'',ROI);'];
else
	cmd=[MSpScn,'=MSpUnspec2(SpecName,scNum,MotDetOff);'];
end;
eval(cmd);
cmd=[MSpScn,'=setfield(',MSpScn,',''lam'',lambda);'];
eval(cmd);
if exist('alfi'),
	cmd=[MSpScn,'.alfi=alfi;'];
	eval(cmd);
end;
if exist('c0'),
	if ~isempty(c0),
		cmd=[MSpScn,'.c0=c0;'];
		eval(cmd);
	end;
end;
if ~isempty(cpd),
	cmd=[MSpScn,'.cpd=cpd;'];
	eval(cmd);
else
	warndlg('Channels/degree not properly defined.');
end;

set(hndMainGUI,'Visible','On');
cscn=eval(scn);
if isfield(cscn,'PSD'),
	msgbox(['Linear position sensitive detector data were loaded ',...
		'as variable PSD in ',...
		'the dataset ', MSpScn, ' and can be ploted or normalized.']);
else
	warndlg('Can not load linear position sensitive detector data.');
end;
close(f0);
end

function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(f0);
end;

end
 
 
 

