function fig_hdl = MSpGUIAbout
% MatSpec GUI
% (c) J. Novak

% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn MSpVersion;
persistent valPopExportToASCIIDatasetToHandle
persistent valListVariablesToSave
persistent strEditFilenameRoot TargetDirectory
persistent figPositon

if isempty(figPositon),
	figPositon=[520 479 530 321];
end;

fig_hdl=findobj('tag','figExportASCII');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
hnd.figMSpGUIAbout = figure(	'Tag', 'figMSpGUIAbout', ...
	'Units', 'pixels', ...
	'Position', figPositon, ...
	'Name', 'MatSpecGUI: About', ...
	'MenuBar', 'none', ...
	'Visible','Off',...
	'NumberTitle', 'off', ...
	'Color', get(0,'DefaultUicontrolBackgroundColor'),...
	'CloseRequestFcn',{@closeIt});

% --- STATIC TEXTS -------------------------------------
hnd.txtTitleAboutMatSpec = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtTitleAboutMatSpec', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [130 282 220 25], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',18.667,...
	'FontWeight', 'bold', ...
	'BackgroundColor', [.5 1 1], ...
	'String', 'About MatSpecGUI');

hnd.txMSpVersion = uicontrol(	'Parent',hnd.figMSpGUIAbout, ...
	'Tag', 'txMSpVersion', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [360 282 50 25], ...
	'FontName', 'Times Roman', ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'FontWeight', 'normal', ...
	'BackgroundColor', [1 1 1], ...
	'String', {'version',MSpVersion});


hnd.txtDescriptionTxt = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtDescriptionTxt', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [89 220 430 40], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'BackgroundColor', [1 1 1], ...
	'String', {['An utility for 2D imaging and handling of x-ray data ',...
	'acquired via SPEC software from a linear ',...
	'position-sensitive detector.']}, ...
	'HorizontalAlignment', 'center');

hnd.txtAuthors = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtAuthors', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 158 79 15], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'FontWeight', 'bold', ...
	'BackgroundColor', [1 1 1], ...
	'String', 'Author:', ...
	'HorizontalAlignment', 'left');

hnd.txtAuthorsTxt = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtAuthorsTxt', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [89 130 430 80], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'BackgroundColor', [1 1 1], ...
	'String', {'Jiri Novak (novak@physics.muni.cz)','ID10B beamline', ...
	'European synchrotron radiation facility','Grenoble, France '});

hnd.txtLicense = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtLicense', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 81. 79 15], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'FontWeight', 'bold', ...
	'BackgroundColor', [1 1 1], ...
	'String', 'License:', ...
	'HorizontalAlignment', 'left');

hnd.txtLicenseTxt = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtLicenseTxt', ...
	'UserData', [], ...
	'Style', 'edit', ...
	'Units', 'pixels', ...
	'Position', [89 46 430 75], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'BackgroundColor', [1 1 1], ...
	'Max',100,...
	'Enable','inactive',...
	'String', {'Free software distributed under GNU license, see',...
		'http://www.gnu.org/licenses/gpl.html.','',...
		'MatSpecGUI is released WITHOUT ANY WARRANTY and the author ',...
		'can not be held responsible for any problems reulting from ',...
		'any use of this program.','',...
		'Support is provided when there is time available.','',...
		['The author would appreciate that any ',...
		'publication to which usage of this utility contributed ',...
		'acknowledges the work. This concerns ',...
		'especially cases, when the author of the program was ',...
		'directly asked for a consultation or a further ',...
		'development on a request.']});

hnd.txtDescription = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'txtDescription', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [8 235 79 15], ...
	'FontName', 'MS Sans Serif ', ...
	'FontUnits','pixels',...
	'FontSize',12.667,...
	'FontWeight', 'bold', ...
	'BackgroundColor', [1 1 1], ...
	'String', 'Description:', ...
	'HorizontalAlignment', 'left');

% --- PUSHBUTTONS -------------------------------------
hnd.btnOK = uicontrol(	'Parent', hnd.figMSpGUIAbout, ...
	'Tag', 'btnOK', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'pixels', ...
	'Position', [239 11 83 26], ...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'FontWeight', 'bold', ...
	'String', 'OK', ...
	'Callback', @btnOK_Callback);

% Save hnd structure
guidata(hnd.figMSpGUIAbout,hnd);

% Assign function output
fig_hdl = hnd.figMSpGUIAbout;

% Interventions since here
set(hnd.txtDescriptionTxt, 'String',...
	{['An utility for 2D imaging and handling of x-ray data ',...
	'acquired via SPEC software from a linear ',...
	'position-sensitive detector.']});

set(hnd.txtAuthors,	'String', 'Author:');

set(hnd.txtAuthorsTxt,'String',...
	{'Jiri Novak (novak@physics.muni.cz)','ID10B beamline', ...
	'European synchrotron radiation facility','Grenoble, France '});

set(hnd.txtLicense,'String', 'License:')
set(hnd.txtLicenseTxt,'String', ...
	{		['MatSpecGUI is released WITHOUT ANY WARRANTY and the author ',...
		'can not be held responsible for any problems resulting from ',...
		'any use of this program. ',...
		'Support is provided when there is time available.'],'',...
		['The author would appreciate that any ',...
		'publication to which usage of the program contributed ',...
		'acknowledges the contribution. A reference to the '...
		'program home page '],...
		'http://www.physics.muni.cz/~novak/MatSpecGUI/MatSpecGUI.php',...
		'can be made.','',...
		['MatSpecGUI is a free software distributed under the GNU General ',...
		'Public License, see ',...
		'http://www.gnu.org/licenses/gpl.html.']...
		});
set(hnd.txtDescription,	'String', 'Description:');
set(hnd.txMSpVersion,'String', {'version',MSpVersion});


movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function btnOK_Callback(hObject,evendata)
		figPositon=get(hnd.figMSpGUIAbout,'Position');
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end
	function closeIt(hObject,evendata)
		figPositon=get(hnd.figMSpGUIAbout,'Position');
		set(hndMainGUI,'Visible','On');
		delete(fig_hdl);
	end

end
