function SaveToMatFile
% SaveToMatFile.m
% MatSpecGUI
% Jiri Novak, ESRF, Grenoble, France
% Generated on: 21-Oct-2009 17:03:28          
% Description :
%-------------------------------------------------------------------------------

% --- VARIABLES ----------------------------------
global MSpScnList MSpf  MSpScn;
persistent valPopDataSetToSave valPopOutputFormat
persistent currDir
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;
if isempty(valPopDataSetToSave),
	valPopDataSetToSave=1;
end;
if isempty(valPopOutputFormat),
	valPopOutputFormat=1;
end;
MlbVersion=version;
ind=findstr('.',MlbVersion);
ind=ind(2);
if (str2double(MlbVersion(1:ind-1))>=7.3),
	OutputFormats={'Standard Mat-file','';'HDF5','-v7.3'};
else
	OutputFormats={'Standard Mat-file',''};
end;
if isempty(currDir),
	currDir='./';
end;
fig_hdl=findobj('tag','figSaveToMatFile');
hndMainGUI=findobj('Tag','figGUIMatSpec');
set(hndMainGUI,'Visible','Off');
if isempty(fig_hdl),
% --- FIGURE -------------------------------------
handles.figSaveToMatFile = figure(	'Tag', 'figSaveToMatFile', ...
	'Units', 'pixels', ...
	'Position', [520 650 313 150], ...
	'Name', 'MatSpecGUI: Save To Mat-file', ...
	'MenuBar', 'none', ...
	'NumberTitle', 'off', ...
	'CloseRequestFcn',{@closeIt},...
	'Color', get(0,'DefaultUicontrolBackgroundColor'));

% --- STATIC TEXTS -------------------------------------
handles.txtDataSetToSave = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtDataSetToSave', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [10 87 155 22], ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Data-set to be saved:', ...
	'HorizontalAlignment', 'left');

handles.txtOutputFormat = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtOutputFormat', ...
	'UserData', zeros(1,0), ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [10 49 155 22], ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Output format:', ...
	'HorizontalAlignment', 'left');

handles.txtTitleSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'txtTitleSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'text', ...
	'Units', 'pixels', ...
	'Position', [47.0000000000001 119 211 33], ...
	'FontSize', 14, ...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String', 'Save to Mat-file');

% --- PUSHBUTTONS -------------------------------------
handles.pushSaveSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'pushSaveSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'pixels', ...
	'Position', [62 10 78 22], ...
	'FontWeight', 'bold', ...
	'String', 'Save', ...
	'Callback', @pushSaveSaveToMatFile_Callback);

handles.pushCloseSaveToMatFile = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'pushCloseSaveToMatFile', ...
	'UserData', [], ...
	'Style', 'pushbutton', ...
	'Units', 'pixels', ...
	'Position', [181 10 72 22], ...
	'FontWeight', 'bold', ...
	'String', 'Close', ...
	'Callback', @pushCloseSaveToMatFile_Callback);

% --- POPUP MENU -------------------------------------
handles.popDataSetToSave = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'popDataSetToSave', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'pixels', ...
	'Position', [170 87 130 22], ...
	'String', '---------', ...
	'Callback', @popDataSetToSave_Callback, ...
	'CreateFcn', @popDataSetToSave_CreateFcn);

handles.popOutputFormat = uicontrol(	'Parent', handles.figSaveToMatFile, ...
	'Tag', 'popOutputFormat', ...
	'UserData', [], ...
	'Style', 'popupmenu', ...
	'Units', 'pixels', ...
	'Position', [170 49 130 22], ...
	'String', '---------', ...
	'Callback', @popOutputFormat_Callback, ...
	'CreateFcn', @popOutputFormat_CreateFcn);

% Assign function output
fig_hdl = handles.figSaveToMatFile;

movegui(fig_hdl,'center');
set(fig_hdl,'visible','on');
else
figure(fig_hdl);
end;

%-------------------------------------------------------------------------------
	function pushSaveSaveToMatFile_Callback(hObject,evendata),
		SaveOpt=OutputFormats{valPopOutputFormat,2};
		[filename,currDir]=uiputfile({'*.mat';'*.hdf'},'Save As',...
			[currDir,MSpScn,'.mat']);
		if isequal(filename,0) | isequal(currDir,0)
			 errordlg('User selected Cancel','Save As Canceled','Modal')
			 return;
		end
		ffname=fullfile(currDir,filename);
		save(ffname,MSpScn,SaveOpt);
		msgbox(sprintf('Data-set %s was saved to the file %s',MSpScn,...
			ffname),'MatSpec: Data-set saved');	
	end

%-------------------------------------------------------------------------------
	function pushCloseSaveToMatFile_Callback(hObject,evendata)
		set(hndMainGUI,'Visible','On');
		close(fig_hdl);
	end

%-------------------------------------------------------------------------------
	function popDataSetToSave_Callback(hObject,evendata)
		MSpScn=getPopCurStr(handles.popDataSetToSave);
	end

%-------------------------------------------------------------------------------
	function popDataSetToSave_CreateFcn(hObject,evendata)
		if (~isempty(MSpScn) && ~isempty(MSpScnList)),
				ii=find(strcmp(MSpScn,MSpScnList),1);
				set(hObject,'String',MSpScnList,'Value', ii);
		elseif length(MSpScnList)>0,
				set(handles.popDataSetToHandlePlot,'String',MSpScnList,'Value', 1);
		else
				set(hObject,'String',{'------'});
		end;
	end

%-------------------------------------------------------------------------------
	function popOutputFormat_Callback(hObject,evendata)
		valPopOutputFormat=get(handles.popOutputFormat,'Value');
	end

%-------------------------------------------------------------------------------
	function popOutputFormat_CreateFcn(hObject,evendata)
		set(hObject,'String',OutputFormats(:,1),'Value',valPopOutputFormat);
	end
%-------------------------------------------------------------------------------
function closeIt(gcbf,ar2);
set(hndMainGUI,'Visible','On');
delete(fig_hdl);
end;
%-------------------------------------------------------------------------------
	function myFieldNames=retrieveDataFields;
		% retrieve fields of the dataset
		myFieldNames={};
		flgIsStruct=0;
		if ~isempty(MSpScn),
				if  iscell(MSpScn),
						MSpScn=MSpScn{1};
				end;
				cmd=['flgIsStruct=isstruct(', MSpScn,');'];
				eval(cmd);
				if flgIsStruct,
						cmd=['myFieldNames=fieldnames(',MSpScn,');'];
						eval(cmd);
				else
						myFieldNames={};
				end;
		else,
				myFieldNames={};
		end;
	end;

	function str=getPopCurStr(hndl),
		strs=get(hndl,'String');
		ii=get(hndl,'Value');
		str=strs{ii};
	end;
	function val1=setPopFieldNames( hndl, str, val),
		% Set popup menu field names and the current filed (val)
		% hndl ... handle to the popup menu
		% str ... string
		% val ... value
		if (isempty(str)),
			lstr=1;
			str={'------'};
		else if (iscell(str)),
			lstr=length(str);
		else
			lstr=1;
		end;
		end;

		if (val>lstr),
			val=1;
		end;
		
		set(hndl,'String',str);
		set(hndl,'Value',val);
		val1=val;
	end;
end
