%Transform2QSpace.m
 
function Transform2QSpace

%% Initialization
global MSpScnList  MSpf  MSpScn
% global for this menu
global funcName ArgList text2display hndMainGUI hnd
% Config file name
persistent ConfigFName
ConfigFName='Ang2Q.cfg';


% Make datasets known here
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
		cmd=['global ', MSpScnList{ii}];
		eval(cmd);
	end;
end;
 
%normally read from file 'Ang2A.cfg'
[funcName,ArgList,text2display]=MSpGUIReadQPlotCfg(ConfigFName);
 
if ~isempty(MSpScnList),
	n=length(MSpScnList );
	for ii = 1:n
			cmd=['global ', MSpScnList{ii}];
			eval(cmd);
	end;
end;

 
hnd.f0=figure('Visible','off',...
	'MenuBar', 'none', ...
'Position',[20,20,520,500],...
'Name','MatSpecGUI: Transform to Q-Space',...
'tag','TransformToQSpace',...
'Visible','off',...
	'CloseRequestFcn',{@closeIt});
hndMainGUI=findobj('Tag','figGUIMatSpec');
movegui(hnd.f0,'center');
set(hndMainGUI,'visible','off');

%TRANSFORM TO Q-SPACE
hnd.hlbPlotRoughData = uicontrol('Style','text',...
	'FontUnits','pixels',...
'FontSize',18.667,...
	'FontWeight', 'bold', ...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'String','Transform to Q-space',...
	'FontWeight', 'Bold','Position',[110,470,300,25],...
	'TooltipString',['Transforms angular coordinates to ',...
		'reciprocal-space coordinates for a given dataset.']...
	);
	
hnd.txtDataSet2Handle=uicontrol('Style','text',...
	'BackgroundColor', [0.5 0.5 0.5], ...
	'Position',[20,440,180,20],...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'String','Dataset to be handled:');
hnd.hpopDataSet2BeTransformed=uicontrol('Style',...
	'popupmenu',...
	'Position',[220,440,80,20],...
	'Callback',{@popDataSet2BeTransformed_Callback});

if (~isempty(MSpScn) && ~isempty(MSpScnList)),
    ii=find(strcmp(MSpScn,MSpScnList),1);
    set(hnd.hpopDataSet2BeTransformed,'String',MSpScnList,'Value', ii);
elseif length(MSpScnList)>0,
    set(hnd.hpopDataSet2BeTransformed,'String',MSpScnList,'Value', 1);
else
    set(hnd.hpopDataSet2BeTransformed,'String','---');
end;

% Retrive fields of the dataset
flgIsStruct=0;
if ~isempty(MSpScn),
    if  iscell(MSpScn),
        MSpScn=MSpScn{1};
    end;
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={}
    end;
else,
    myFieldNames={}
end;

%TRANSFORMATION FUNCTION
global CurrentFuncName;
if isempty(CurrentFuncName),
	if ~isempty(funcName),
		CurrentFuncName=funcName{1};
	else,
		CurrentFuncName='---';
	end;
end;
hnd.hlbTransformationfunction = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',...
	'Transformation function:','Position',[20,400,180,20]);
hnd.hedTransformationfunction = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',...
	CurrentFuncName,'Position',[220,400,120,20]);
hnd.hpbTransformationfunction = uicontrol('Style','pushbutton','String', ...
	'TRANSFORM',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'Position',[400,400,100,20],'Callback',...
	{@pbTransformationfunction_Callback});



%ARGUMENTS TRANSFORMATION FUNCTION
global CurrentArgList;
if isempty(CurrentArgList),
	if ~isempty(ArgList),
		CurrentArgList=ArgList{1};
	else,
		CurrentArgList={};
	end;
end;

lbargs={'Arguments','of the', 'transfromation', 'function:'};
hnd.hlbArgTransFunc = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',lbargs,'Position',[20,300,90,80]);

hnd.hlbArg2Add = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String','Arg to Add:','Position',[20,270,90,20]);

hnd.hlistbArgTransFunct=uicontrol('Style','listbox','String',...
	CurrentArgList,'Position', ...
	[120,300,100,80]);%'callback',{@listbArgTransFunct_Callback});


persistent valArg2Add;
if isempty( valArg2Add),
	valArg2Add=1;
end;
% retrive fields of the dataset
flgIsStruct=0;
if ~isempty(MSpScn),
    if  iscell(MSpScn),
        MSpScn=MSpScn{1};
    end;
    cmd=['flgIsStruct=isstruct(', MSpScn,');'];
    eval(cmd);
    if flgIsStruct,
        cmd=['myFieldNames=fieldnames(',MSpScn,');'];
        eval(cmd);
    else
        myFieldNames={}
    end;
else,
    myFieldNames={}
end;

hnd.hpopArg2Add= uicontrol('Style','popup','String',myFieldNames,...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'Position',[120,270,100,20],'Callback',{@popArgTransFunct_Callback});
set( hnd.hpopArg2Add, 'val', valArg2Add);

hnd.hpbArgsAdd =uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','Add','Position',...
	[20,240,100,20],'Callback',{@pbArgsAdd_Callback});
hnd.hpbArgsRemove =uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','Remove',...
	'Position',[120,240,100,20],'Callback',{@pbArgsRemove_Callback});

% Current comments
global CurrentComment;
if isempty(CurrentComment),
	if ~isempty(text2display),
		CurrentComment=text2display{1};
	else,
		CurrentComment='---';
	end;
end;
hnd.hlbComments2Save = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',...
	CurrentComment,'Position',[230,240,270,110],'Max',2);

hnd.hlbComments = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',...
	'Comments to save:','Position',[230,360,170,20]);
hnd.hpbSaveCfg = uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String','Save cfg.',...
	'Position',[420,360,80,20],'Callback',{@pbSaveCfg_Callback});

%LOAD FUNCTION NAME + ARGUMENTS FORM CONFIGURATION FILE
hnd.hfrLoadFunctionName = uicontrol('Style',...
	'frame','Position',[20,20,480,200]);
hnd.hlbLoadFunctionNameTitle = uicontrol('Style','text',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'BackgroundColor', [0.5 0.5 0.5], ...
'String',...
	' Load function name + arguments from configuration file: ',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'Position',[30,190,440,20]);

%set(hedTransformationfunction,'String',funcName{1});
hnd.hpopTransformationFunction =uicontrol('Style','popupmenu',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','left',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
	'String',funcName,...
	'Position',[390,90,100,20],'Callback',...
	{@popTransformationFunction_Callback});

hnd.hlbLoadFunctionName = uicontrol('Style','edit',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',...
	text2display{1},'BackgroundColor','white',...
	'Position',[30,30,350,150],...
	'max',2,...
	'Enable', 'inactive' ...
	);
hnd.hpbLoad = uicontrol('Style','pushbutton',...
	'FontName', 'MS Sans Serif ', ...
	'HorizontalAlignment','center',...
	'FontUnits','pixels',...
	'FontSize',10.667,...
'String',{'LOAD'},...
	'Position',[390,60,100,20],'Callback',{@pbLoad_Callback});
set(hnd.f0,'Visible','on');
guidata(hnd.f0,hnd);


function pbArgsRemove_Callback(hObject,eventdata)
%		global hnd
    str22=get(hnd.hlistbArgTransFunct,'String');
    val=get(hnd.hlistbArgTransFunct,'Value');
    disp(str22);
    disp(val);
    str22(val)=[];
    disp(str22);
    set(hnd.hlistbArgTransFunct,'String',str22);
    set(hnd.hlistbArgTransFunct,'Value',1);

end

function pbArgsAdd_Callback(hObject,eventdata)
%  global hnd 
	strr=get(hnd.hlistbArgTransFunct,'String');
	val1=get(hnd.hlistbArgTransFunct,'Value');
	n=length(strr);
	disp(val1);
	disp(n);
	disp(strr);
    
	str22=get(hnd.hpopArg2Add,'String');
	val2=get(hnd.hpopArg2Add,'Value');
	str2add=str22{val2};
% strr{n+1}=str2add;
	strr={strr{1:val1},strr{val1:n}};
	strr{val1}=str2add;
	disp(strr);
	set(hnd.hlistbArgTransFunct,'String',strr);
end

function pbTransformationfunction_Callback(hObject,eventdata)
%  global hnd hndMainGUI
	% collect function name + arguments
	str=get(hnd.hpopDataSet2BeTransformed,'String');
	val=get(hnd.hpopDataSet2BeTransformed,'Value');
	MSpScn=str{val};
	CurrentFuncName=get(hnd.hedTransformationfunction,'string');
	CurrentArgList=get(hnd.hlistbArgTransFunct,'string');
	% create command structure
	Ang2Q={CurrentFuncName,CurrentArgList{:}};
	flgUnspec=0;
	flgNormalize=0;
	flgAng2Q=1;
	flgPlotPSD=0;
	flgAutoGridEst=0;
	flgGridQ=0;
	flgPlotGrid=0;
	flgPrintPlot=0;
	flgSaveMat=0;
	flgLoadMat=0;
	flgSaveAscii=0;
%	MSpMain2;
	cmd=[MSpScn,'=',Ang2Q{1},'(',MSpScn,',Ang2Q{2:end});'];
	eval(cmd);
	hThisFig=findobj('tag','TransformToQSpace');
	set(hndMainGUI,'Visible','On');
	msgbox(['Qx,Qy,Qz were calculated and added to dataset ',...
	MSpScn,'.']);
	close(hThisFig);
end

function popTransformationFunction_Callback(hObject,eventdata)
%  global hnd 
  str0=get(hnd.hpopTransformationFunction,'String');
	val=get(hnd.hpopTransformationFunction,'Value');
	set( hnd.hlbLoadFunctionName,'String',text2display{val});
end

function popArgTransFunct_Callback(hObject,eventdata),
%  global hnd 
	valArg2Add=get( hnd.hpopArg2Add, 'val');
end

function pbLoad_Callback(hObject,eventdata)
%  global hnd 
	strs=get(hnd.hpopTransformationFunction,'String');
	val=get(hnd.hpopTransformationFunction,'value');
	CurrentFuncName=strs{val};
	set(hnd.hedTransformationfunction,'string',CurrentFuncName);
	CurrentArgList=ArgList{val};
	set(hnd.hlistbArgTransFunct,'string',CurrentArgList);
	CurrentComment=text2display{val};
	set(hnd.hlbComments2Save,'string',CurrentComment);
end

function pbSaveCfg_Callback(hObject,eventdata),
	CurrentFuncName=get(hnd.hedTransformationfunction,'string');
	CurrentArgList=get(hnd.hlistbArgTransFunct,'string');
	CurrentComment=get(hnd.hlbComments2Save,'string');
	CurrentComment=cellstr(CurrentComment);
	MSpGUIWriteQPlotCfg(ConfigFName,CurrentFuncName,...
		CurrentArgList,CurrentComment);
	msgbox(sprintf(['Transformation function ', ...
		'parameters were saved to %s'], which(ConfigFName)));
end

function closeIt(source, eventdata),
%		global hndMainGUI hnd
		set(hndMainGUI,'Visible','On');
		delete(hnd.f0);
end

end

 
 

